<?php

namespace Objectiv\Plugins\Checkout\Admin;

class AdminPluginsPageManager {
	protected $cfw_admin_url;

	public function __construct( string $cfw_admin_url ) {
		$this->cfw_admin_url = $cfw_admin_url;
	}

	public function init() {
		add_filter( 'plugin_action_links_' . plugin_basename( CFW_MAIN_FILE ), array( $this, 'add_action_link' ), 10, 1 );
	}

	public function add_action_link( $links ) {
		$custom        = array();
		$custom['pro'] = sprintf(
			'<a href="%1$s" aria-label="%2$s" target="_blank" rel="noopener noreferrer" 
				style="color: #00a32a; font-weight: 700;" 
				onmouseover="this.style.color=\'#008a20\';" 
				onmouseout="this.style.color=\'#00a32a\';"
				>%3$s</a>',
			esc_url(
				add_query_arg(
					[
						'utm_content'  => 'Get+CheckoutWC+Pro',
						'utm_campaign' => 'liteplugin',
						'utm_medium'   => 'all-plugins',
						'utm_source'   => 'WordPress',
					],
					'https://www.checkoutwc.com/lite-upgrade/'
				)
			),
			cfw_esc_attr__( 'Upgrade to CheckoutWC Pro', 'checkout-wc' ),
			cfw_esc_html__( 'Get CheckoutWC Pro', 'checkout-wc' )
		);

		$custom['settings'] = sprintf(
			'<a href="%s" aria-label="%s">%s</a>',
			esc_url( $this->cfw_admin_url ),
			cfw_esc_attr__( 'Go to CheckoutWC Lite Settings page', 'checkout-wc' ),
			cfw_esc_html__( 'Settings', 'checkout-wc' )
		);

		return array_merge( $custom, (array) $links );
	}
}
